JUCE: dsp::LinkwitzRileyFilter< SampleType > Class Template Reference

JUCE

Public Types | Public Member Functions | List of all members
dsp::LinkwitzRileyFilter< SampleType > Class Template Reference
juce_dsp » processors

A filter class designed to perform multi-band separation using the TPT (Topology-Preserving Transform) structure. More...

`#include <juce_LinkwitzRileyFilter.h>`

## Public Types
using | Type = LinkwitzRileyFilterType

## Public Member Functions
| LinkwitzRileyFilter ()
| Constructor. More...
void | setType (Type newType)
| Sets the filter type. More...
void | setCutoffFrequency (SampleType newCutoffFrequencyHz)
| Sets the cutoff frequency of the filter in Hz. More...
Type | getType () const noexcept
| Returns the type of the filter. More...
SampleType | getCutoffFrequency () const noexcept
| Returns the cutoff frequency of the filter. More...
void | prepare (const ProcessSpec &spec)
| Initialises the filter. More...
void | reset ()
| Resets the internal state variables of the filter. More...
template<typename ProcessContext >
void | process (const ProcessContext &context) noexcept
| Processes the input and output samples supplied in the processing context. More...
SampleType | processSample (int channel, SampleType inputValue)
| Performs the filter operation on a single sample at a time. More...
void | processSample (int channel, SampleType inputValue, SampleType &outputLow, SampleType &outputHigh)
| Performs the filter operation on a single sample at a time, and returns both the low-pass and the high-pass outputs of the TPT structure. More...
void | snapToZero () noexcept
| Ensure that the state variables are rounded to zero if the state variables are denormals. More...

## Detailed Description

template<typename SampleType>
class dsp::LinkwitzRileyFilter< SampleType >

A filter class designed to perform multi-band separation using the TPT (Topology-Preserving Transform) structure.

Linkwitz-Riley filters are widely used in audio crossovers that have two outputs, a low-pass and a high-pass, such that their sum is equivalent to an all-pass filter with a flat magnitude frequency response. The Linkwitz-Riley filters available in this class are designed to have a -24 dB/octave slope (LR 4th order).

## Member Typedef Documentation

## ◆ Type

template<typename SampleType >

using dsp::LinkwitzRileyFilter< SampleType >::Type = LinkwitzRileyFilterType

## Constructor & Destructor Documentation

## ◆ LinkwitzRileyFilter()

template<typename SampleType >

dsp::LinkwitzRileyFilter< SampleType >::LinkwitzRileyFilter | ( |  | ) |

Constructor.

## Member Function Documentation

## ◆ setType()

template<typename SampleType >

void dsp::LinkwitzRileyFilter< SampleType >::setType | ( | Type | newType | ) |

Sets the filter type.

## ◆ setCutoffFrequency()

template<typename SampleType >

void dsp::LinkwitzRileyFilter< SampleType >::setCutoffFrequency | ( | SampleType | newCutoffFrequencyHz | ) |

Sets the cutoff frequency of the filter in Hz.

## ◆ getType()

template<typename SampleType >

Type dsp::LinkwitzRileyFilter< SampleType >::getType | ( |  | ) | const
| noexcept

Returns the type of the filter.

## ◆ getCutoffFrequency()

template<typename SampleType >

SampleType dsp::LinkwitzRileyFilter< SampleType >::getCutoffFrequency | ( |  | ) | const
| noexcept

Returns the cutoff frequency of the filter.

## ◆ prepare()

template<typename SampleType >

void dsp::LinkwitzRileyFilter< SampleType >::prepare | ( | const ProcessSpec & | spec | ) |

Initialises the filter.

## ◆ reset()

template<typename SampleType >

void dsp::LinkwitzRileyFilter< SampleType >::reset | ( |  | ) |

Resets the internal state variables of the filter.

## ◆ process()

template<typename SampleType >
template<typename ProcessContext >

void dsp::LinkwitzRileyFilter< SampleType >::process | ( | const ProcessContext & | context | ) |
| noexcept

Processes the input and output samples supplied in the processing context.

References jassert, dsp::LinkwitzRileyFilter< SampleType >::processSample(), and dsp::LinkwitzRileyFilter< SampleType >::snapToZero().

## ◆ processSample() [1/2]

template<typename SampleType >

SampleType dsp::LinkwitzRileyFilter< SampleType >::processSample | ( | int | channel,
|  | SampleType | inputValue
| ) |  |

Performs the filter operation on a single sample at a time.

Referenced by dsp::LinkwitzRileyFilter< SampleType >::process().

## ◆ processSample() [2/2]

template<typename SampleType >

void dsp::LinkwitzRileyFilter< SampleType >::processSample | ( | int | channel,
|  | SampleType | inputValue,
|  | SampleType & | outputLow,
|  | SampleType & | outputHigh
| ) |  |

Performs the filter operation on a single sample at a time, and returns both the low-pass and the high-pass outputs of the TPT structure.

## ◆ snapToZero()

template<typename SampleType >

void dsp::LinkwitzRileyFilter< SampleType >::snapToZero | ( |  | ) |
| noexcept

Ensure that the state variables are rounded to zero if the state variables are denormals.

This is only needed if you are doing sample by sample processing.

Referenced by dsp::LinkwitzRileyFilter< SampleType >::process().

The documentation for this class was generated from the following file:

- juce_LinkwitzRileyFilter.h